# Copyright (c) 2021 AccelByte Inc. All Rights Reserved.
# This is licensed software from AccelByte Inc, for limitations
# and restrictions contact your company contract manager.
#
# Code generated. DO NOT EDIT!

# template file: wrapper.j2

# pylint: disable=duplicate-code
# pylint: disable=line-too-long
# pylint: disable=missing-function-docstring
# pylint: disable=missing-function-docstring
# pylint: disable=missing-module-docstring
# pylint: disable=too-many-arguments
# pylint: disable=too-many-branches
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-lines
# pylint: disable=too-many-locals
# pylint: disable=too-many-public-methods
# pylint: disable=too-many-return-statements
# pylint: disable=too-many-statements
# pylint: disable=unused-import

from typing import Any, Dict, List, Optional, Tuple, Union

from accelbyte_py_sdk.core import HeaderStr
from accelbyte_py_sdk.core import get_namespace as get_services_namespace
from accelbyte_py_sdk.core import run_request
from accelbyte_py_sdk.core import run_request_async
from accelbyte_py_sdk.core import same_doc_as

from ..models import ModelsPluginRequest
from ..models import ModelsPluginResponse
from ..models import ModelsResponseError

from ..operations.plugin_config import CreatePluginConfig
from ..operations.plugin_config import DeletePluginConfig
from ..operations.plugin_config import GetPluginConfig
from ..operations.plugin_config import UpdatePluginConfig
from ..models import ModelsPluginRequestExtendTypeEnum
from ..models import ModelsPluginResponseExtendTypeEnum


@same_doc_as(CreatePluginConfig)
def create_plugin_config(
    body: ModelsPluginRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Create plugin configuration (createPluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [CREATE]`
    Required scope: `social`



    ## Description



    This endpoints will create new grpc plugins configuration per namespace

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [CREATE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: POST

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelsPluginRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        201: Created - ModelsPluginResponse (Created)

        400: Bad Request - ModelsResponseError (18301: invalid request body | 20002: validation error)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        409: Conflict - ModelsResponseError (18302: plugins already configured)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = CreatePluginConfig.create(
        body=body,
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(CreatePluginConfig)
async def create_plugin_config_async(
    body: ModelsPluginRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Create plugin configuration (createPluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [CREATE]`
    Required scope: `social`



    ## Description



    This endpoints will create new grpc plugins configuration per namespace

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [CREATE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: POST

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelsPluginRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        201: Created - ModelsPluginResponse (Created)

        400: Bad Request - ModelsResponseError (18301: invalid request body | 20002: validation error)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        409: Conflict - ModelsResponseError (18302: plugins already configured)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = CreatePluginConfig.create(
        body=body,
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(DeletePluginConfig)
def delete_plugin_config(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Delete plugin configuration (deletePluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [DELETE]`
    Required scope: `social`



    ## Description



    This endpoints will delete grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [DELETE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: DELETE

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        204: No Content - (OK)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18306: plugins config not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = DeletePluginConfig.create(
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(DeletePluginConfig)
async def delete_plugin_config_async(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Delete plugin configuration (deletePluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [DELETE]`
    Required scope: `social`



    ## Description



    This endpoints will delete grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [DELETE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: DELETE

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        204: No Content - (OK)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18306: plugins config not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = DeletePluginConfig.create(
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(GetPluginConfig)
def get_plugin_config(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get plugin configuration (getPluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [READ]`
    Required scope: `social`



    ## Description



    This endpoints will get grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [READ]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: GET

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelsPluginResponse (OK)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18304: plugins not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = GetPluginConfig.create(
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(GetPluginConfig)
async def get_plugin_config_async(
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Get plugin configuration (getPluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [READ]`
    Required scope: `social`



    ## Description



    This endpoints will get grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [READ]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: GET

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelsPluginResponse (OK)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18304: plugins not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = GetPluginConfig.create(
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )


@same_doc_as(UpdatePluginConfig)
def update_plugin_config(
    body: ModelsPluginRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Update plugin configuration (updatePluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [UPDATE]`
    Required scope: `social`



    ## Description



    This endpoints will update grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [UPDATE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: PATCH

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelsPluginRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelsPluginResponse (OK)

        400: Bad Request - ModelsResponseError (18308: invalid request body | 20002: validation error)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18309: plugins config not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = UpdatePluginConfig.create(
        body=body,
        namespace=namespace,
    )
    return run_request(request, additional_headers=x_additional_headers, **kwargs)


@same_doc_as(UpdatePluginConfig)
async def update_plugin_config_async(
    body: ModelsPluginRequest,
    namespace: Optional[str] = None,
    x_additional_headers: Optional[Dict[str, str]] = None,
    **kwargs
):
    """Update plugin configuration (updatePluginConfig)

    Required permission: `ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [UPDATE]`
    Required scope: `social`



    ## Description



    This endpoints will update grpc plugins configuration

    Required Permission(s):
        - ADMIN:NAMESPACE:{namespace}:CLOUDSAVE:PLUGINS [UPDATE]

    Required Scope(s):
        - social

    Properties:
        url: /cloudsave/v1/admin/namespaces/{namespace}/plugins

        method: PATCH

        tags: ["PluginConfig"]

        consumes: ["application/json"]

        produces: ["application/json"]

        securities: [BEARER_AUTH]

        body: (body) REQUIRED ModelsPluginRequest in body

        namespace: (namespace) REQUIRED str in path

    Responses:
        200: OK - ModelsPluginResponse (OK)

        400: Bad Request - ModelsResponseError (18308: invalid request body | 20002: validation error)

        401: Unauthorized - ModelsResponseError (Unauthorized)

        403: Forbidden - ModelsResponseError (Forbidden)

        404: Not Found - ModelsResponseError (18309: plugins config not found)

        500: Internal Server Error - ModelsResponseError (20000: internal server error)
    """
    if namespace is None:
        namespace, error = get_services_namespace()
        if error:
            return None, error
    request = UpdatePluginConfig.create(
        body=body,
        namespace=namespace,
    )
    return await run_request_async(
        request, additional_headers=x_additional_headers, **kwargs
    )
